@echo off
ECHO University of Liverpool PowerDown
ECHO Comments and problems to lisa.nelson@liverpool.ac.uk
ECHO Copyright 2006.  Freely usable, modifiable and redistributable, but you may not
ECHO use this in a commercial product.

REM define some variables to avoid typing long names
REM set scriptdir=\\common\dfs\winconf\power-management
set scriptdir=\\fuse\win-desktops\power-management
set shutdown=%scriptdir%\psshutdown.exe /accepteula
set loggedon=%scriptdir%\psloggedon.exe /accepteula
set powersavelog=%systemroot%\powersave.log
set loggedoutstate=%systemroot%\powersave.tmp
set find=%systemroot%\system32\find.exe
set check-wake-conf=%scriptdir%\check-wake-conf
set defrag=%systemroot%\system32\defrag.exe

REM if this computer has the nopowersave flag, bail
if exist %systemdrive%\nopowersave.dat goto end

perl -f %check-wake-conf% || goto end

REM sanity check -- if the executables we're counting on don't exist, bail
if not exist %shutdown% goto end
if not exist %loggedon% goto end

REM get the list of currently logged in users
%loggedon% -l -x >>%powersavelog%
REM look for a keyword that indicates a real user -- this will be the domain name, or computer name if you use workstation accounts.
REM MODIFY THIS FOR YOUR ENVIRONMENT.
REM %loggedon% -l -x | %find% "%computername%"
REM if errorlevel 1 goto nouser
REM IF YOU HAVE MULTIPLE DOMAINS, you can use this construction INSTEAD OF the previous two lines.
REM Substitute your real domains for domain1 etc.
for %%x in (MATHS Administrator %computername%) do %loggedon% -l -x | %find% /v "cyg_server" | %find% /i "%%x" && goto user

goto nouser

:user
echo %date% %time%: user logged in, not powering off.>>%powersavelog%
del /q /f %loggedoutstate%
goto end

:nouser
REM Nasty hack to ensure that nobody was logged in for the last 3 checks before actually shutting down
REM This is to avoid unexpected shutdowns when Windows Updates restart various services and user logons
REM seem to be detected incorrectly.
echo %date% %time% >> %loggedoutstate%
%find% /c " " %loggedoutstate% | %find% /v "1" | %find% /v "2" | %find% /i "%loggedoutstate%" && goto shutdown
echo %date% %time%: user logged in, not powering off yet waiting for further occurences. >> %powersavelog%
goto end

:shutdown
REM issues commands to shut down in 10 seconds
REM the text is there even though it should never be needed; while at the
REM Ctrl-Alt-Del screen (which is where we should be) the shutdown command isn't allowed
REM to interact with the desktop, so the message won't be displayed; it is only there
REM in case the code goes horribly wrong and a user IS logged in; they would get a chance
REM to cancel the shutdown command.  I have never had this happen.
%defrag% c: -f -v
%shutdown% -c -k -m "This computer is about to power itself off to save energy." -t 10
echo %date% %time%: no user for the last 3 checks, powering off.>>%powersavelog%

:end
